#default values:
timeShift = 0#adds n hours to clock
clock_style = 'time and date'
date_style = 'mm/dd/yyyy'
time_style = 'hh:mm'

def displayClock():
    if clock_style == 'time and date':
        Dsp.clock.value = dispTime(time_style) + "  " + dispDate(date_style)
    elif clock_style == 'date and time':
        Dsp.clock.value = dispDate(date_style) + "  " + dispTime(time_style)
    elif clock_style == 'time':
        Dsp.clock.value = dispTime(time_style)
    elif clock_style == 'date':
        Dsp.clock.value = dispDate(date_style)
        
    s=timeControl.time[2]
    add_timer((60-s)*1000, displayClock) 


def dispTime(time_style):
    clock = timeControl.time

    hours = str((clock[0] + timeShift) % 24)
    minutes = "%02d" % (clock[1])

    if time_style == '24h':
        displayed_time = hours + ":" + minutes
    elif time_style == '12hShort':
        displayed_time = str(twelveh(int(hours))) + ":" + minutes
    elif time_style == '12hLong':
        displayed_time = str(twelveh(int(hours))) + ":" + minutes + " " + mora(int(hours))
    else:
        displayed_time = 'time display error'

    return displayed_time


def twelveh(hours):
    #this function returns time when displayed in 12h format.
    #You cannot merely do a %12 if you want 12:00 to be displayed at midday and 0:00 at midnight!
    if hours > 12:
        return (hours - 12)
    else:
        return hours


def mora(hours): #I didn't know how to call this function, so i called it mora which stands for 'morning or afternoon'
    if hours < 12:
        return 'AM'
    else:
        return 'PM'


def dispDate(date_style):
    date = timeControl.date

    day = str(date[2])
    month = str(date[1])
    year = str(date[0])

    #mm or dd or yyyy are month, day or date in numbers (mm/dd/yyyy == 06/23/2005)
    #Mth is an abbreviation of the month (Sep, Oct, Dec, etc...)
    #Month is the full name of the month (September)
    if date_style == 'dd/mm/yyyy': #French style
        displayed_date = day + "/" + month + "/" + year
    elif date_style == 'mm/dd/yyyy':
        displayed_date = month + "/" + day + "/" + year
    elif date_style == 'Mth dd yyyy':
        displayed_date = short_month(int(month)) + " " + day + " " + year
    elif date_style == 'dd, Mth yyyy':
        displayed_date = day + ", " + short_month(int(month)) + " " + year
    elif date_style == 'dd, Mth':
        displayed_date = day + ", " + short_month(int(month))
    elif date_style == 'Mth dd':
        displayed_date = short_month(int(month)) + " " + day
    elif date_style == 'Month dd yyyy':
        displayed_date = full_month(int(month)) + " " + day + " " + year
    elif date_style == 'dd, Month yyyy':
        displayed_date = day + ", " + full_month(int(month)) + " " + year
    elif date_style == 'Month dd':
        displayed_date = full_month(int(month)) + " " + day
    else:
        displayed_date = 'date display error'

    return displayed_date
    
    
def short_month(month):
    if month == 1:
        displayed_month = 'Jan'
    elif month == 2:
        displayed_month = 'Feb'
    elif month == 3:
        displayed_month = 'Mar'
    elif month == 4:
        displayed_month = 'Apr'
    elif month == 5:
        displayed_month = 'May'
    elif month == 6:
        displayed_month = 'Jun'
    elif month == 7:
        displayed_month = 'Jul'
    elif month == 8:
        displayed_month = 'Aug'
    elif month == 9:
        displayed_month = 'Sep'
    elif month == 10:
        displayed_month = 'Oct'
    elif month == 11:
        displayed_month = 'Nov'
    elif month == 12:
        displayed_month = 'Dec'
    else:
        displayed_month = 'short month display error'
    return displayed_month


def full_month(month):
    if month == 1:
        displayed_month = 'January'
    elif month == 2:
        displayed_month = 'February'
    elif month == 3:
        displayed_month = 'March'
    elif month == 4:
        displayed_month = 'April'
    elif month == 5:
        displayed_month = 'May'
    elif month == 6:
        displayed_month = 'June'
    elif month == 7:
        displayed_month = 'July'
    elif month == 8:
        displayed_month = 'August'
    elif month == 9:
        displayed_month = 'September'
    elif month == 10:
        displayed_month = 'October'
    elif month == 11:
        displayed_month = 'November'
    elif month == 12:
        displayed_month = 'December'
    else:
        displayed_month = 'full month display error'
    return displayed_month


def pref_cb(key, value):
    displayClock()


displayClock()
